
-- # import Property

-- proof rules

reflexivity (A:Set) : (x:A) -> x == x
reflexivity = fol-plugin()

transitivity (A:Set) : (x,y,z : A) -> x == y ==> y == z ==> x == z
transitivity = fol-plugin()

symmetry (A:Set) : (x,y:A) -> x == y ==> y == x
symmetry = fol-plugin()

substitutivity (A:Set) : (P : A -> Prop) -> (x, y : A) ->
                  x == y ==> P x ==> P y
substitutivity P = fol-plugin()

congruence (A, B : Set) : (f : A -> B) -> (x, y : A) ->
                  x == y -> f x == f y
congruence f x y xy =
  substitutivity  (\z -> f x == f z) x y `impE` xy `impE` 
                  (reflexivity (f x))
